Index: ChangeLog
===================================================================
--- ChangeLog	(revision 562)
+++ ChangeLog	(working copy)
@@ -1,3 +1,36 @@
+[Changes for 6.0.10 - March 4, 2005]
+
+> Pugs Internals
+    * massive -Wall cleanup.
+    * work on Pugs extension mechanisms (XS for Pugs)
+    * support for basic read, write, append I/O
+    * added system(), chmod(), chop() and chomp()
+    * pretting printing now works
+    * added the beginings of a Config module
+    * ported to GHC 6.4 pre-release
+    * much work on junctions
+> Documentation
+    * kwid, kwid and more kwid
+    * zh-cn and zh-tw translations of the Apocryphon
+    * Haskell source documentation begun
+    * begun kwid documentation for Test.pm
+> Tests
+    * test, tests and more tests, we now have over 1050
+    * added several tests for unimplemented features
+> Bug Fixes
+    * fixed double-evaluation bug
+    * fixed "@a" interpolation bug
+    * postfix -- now returns the value instead of numified value
+    * bare blocks work properly in void context {}    
+    * fixed grep/map/push/unshift parsing so they are properly binOp now
+    * fixed prefix function parsing bug that eats more parens than it should
+> Examples
+    * added tail recursive nested worker multisubs into fp.p6
+    * hanoi.p6 has been added
+    * several new junctions examples
+> Misc.
+    * complete reworking of the build system
+
 [Changes for 6.0.9 - February 28, 2005]
 
 * First Perl 6 module: Test.pm.
Index: t/op/shift.t
===================================================================
--- t/op/shift.t	(revision 562)
+++ t/op/shift.t	(working copy)
@@ -59,13 +59,13 @@
 is(shift(@s2), 1, 'inline shift(@s2) works');
 
 is(+@s2, 3, 'we have 3 elements in our list');
-todo_is(shift @s2, 2, 'inline shift @s2 works');
+is(shift @s2, 2, 'inline shift @s2 works');
 
-todo_is(+@s2, 2, 'we have 2 elements in our list');
-todo_is(@s2.shift(), 3, 'inline @s2.shift() works');
+is(+@s2, 2, 'we have 2 elements in our list');
+is(@s2.shift(), 3, 'inline @s2.shift() works');
 
-todo_is(+@s2, 1, 'we have 1 elements in our list');
-todo_is(@s2.shift, 4, 'inline @s2.shift works');
+is(+@s2, 1, 'we have 1 elements in our list');
+is(@s2.shift, 4, 'inline @s2.shift works');
 
 is(+@s2, 0, 'we have no elements in our list');
 ok(!defined(shift(@s2)), 'again, the list is exhausted and we get undef');
Index: t/op/push.t
===================================================================
--- t/op/push.t	(revision 562)
+++ t/op/push.t	(working copy)
@@ -31,7 +31,7 @@
 #
 # See the end of this file for tests which illustrate this issue.
 
-plan 28;
+plan 27;
 
 # basic push tests
 
@@ -84,11 +84,10 @@
 is(@push3[2], 3, 'got the expected element');
 
 my @val2 = (4, 5);
-push @push3, @val2;  # the lists should not flatten here
-todo_is(+@push3, 4, 'we have 4 elements in the list');
-todo_is(+@push3[3], 2, 'we have 2 elements in the sub-list');
-is(@push3[3][0], 4, 'got the expected element');
-todo_is(@push3[3][1], 5, 'got the expected element');
+push @push3, @val2;  
+is(+@push3, 5, 'we have 5 elements in the list');
+is(@push3[3], 4, 'got the expected element');
+is(@push3[4], 5, 'got the expected element');
 
 # now for the push() on an uninitialized list issue
 
Index: t/op/unshift.t
===================================================================
--- t/op/unshift.t	(revision 562)
+++ t/op/unshift.t	(working copy)
@@ -22,7 +22,7 @@
 #     42
 #     1
 
-plan 37;
+plan 39;
 
 # basic unshift tests
 
@@ -84,11 +84,13 @@
 is(@unshift3[2], 3, 'got the expected element');
 
 my @val2 = (4, 5);
-unshift @unshift3, @val2;  # the lists should not flatten here
-todo_is(+@unshift3, 4, 'we have 4 elements in the list');
-todo_is(+@unshift3[0], 2, 'we have 2 elements in the sub-list');
-is(@unshift3[0][0], 4, 'got the expected element');
-todo_is(@unshift3[0][1], 5, 'got the expected element');
+unshift @unshift3, @val2;  
+is(+@unshift3, 5, 'we have 5 elements in the list');
+is(@unshift3[0], 4, 'got the expected element');
+is(@unshift3[1], 5, 'got the expected element');
+is(@unshift3[2], 1, 'got the expected element');
+is(@unshift3[3], 2, 'got the expected element');
+is(@unshift3[4], 3, 'got the expected element');
 
 # now for the unshift() on an uninitialized list issue
 
